dovecot panic

Bug #1018579 reported by Barry Warsaw on 2012-06-27
10
This bug affects 1 person
Affects Status Importance Assigned to Milestone
dovecot (Ubuntu)
Critical
Unassigned
Precise
Critical
Serge Hallyn

Bug Description

SRU information:

See below for detailed description. tl;dr: Dovecot continuously panics, preventing local delivery. Mail clients cannot connect or read their mail. This is a critical crash which is not fixed by restarting dovecot, rebooting, or anything else.

[Test Case]
I don't have a way to reproduce it or trigger the problem. The start of the relevant thread in upstream's mailing list is here: http://www.dovecot.org/list/dovecot/2012-March/064717.html

[Regression Potential]
Seems low. After having applied a local build of the 12.04 dovecot package with this patch applied (see merge proposal), the bug appears fixed, with no regressions observed so far.

I'm seeing this now in my 12.04 /var/log/mail.log:

Jun 27 16:25:19 wreckers dovecot: imap(barry): Error: Raw backtrace: /usr/lib/dovecot/libdovecot.so.0(+0x380ca) [0x7effc6c080ca] -> /usr/lib/dovecot/libdovecot.so.0(+0x3810e) [0x7effc6c0810e] -> /usr/lib/dovecot/libdovecot.so.0(i_fatal+0) [0x7effc6be1a67] -> /usr/lib/dovecot/libdovecot-storage.so.0(+0x8f9fb) [0x7effc6edd9fb] -> /usr/lib/dovecot/libdovecot-storage.so.0(mail_index_sync_ext_intro+0x225) [0x7effc6ede985] -> /usr/lib/dovecot/libdovecot-storage.so.0(mail_index_sync_record+0x522) [0x7effc6ee09a2] -> /usr/lib/dovecot/libdovecot-storage.so.0(mail_index_sync_map+0x1ac) [0x7effc6ee144c] -> /usr/lib/dovecot/libdovecot-storage.so.0(mail_index_map+0x130) [0x7effc6ed2f30] -> /usr/lib/dovecot/libdovecot-storage.so.0(+0x80077) [0x7effc6ece077] -> /usr/lib/dovecot/libdovecot-storage.so.0(mail_index_open+0x1e0) [0x7effc6ece310] -> /usr/lib/dovecot/libdovecot-storage.so.0(index_storage_mailbox_open+0xbc) [0x7effc6e934ac] -> /usr/lib/dovecot/libdovecot-storage.so.0(+0x60b48) [0x7effc6eaeb48] -> /usr/lib/dovecot/libdovecot-storage.so.0(+0x615c0) [0x7effc6eaf5c0] -> /usr/lib/dovecot/libdovecot-storage.so.0(+0x28f7c) [0x7effc6e76f7c] -> dovecot/imap(cmd_select_full+0x180) [0x7effc7350320] -> dovecot/imap(+0x1119d) [0x7effc735319d] -> dovecot/imap(+0x11275) [0x7effc7353275] -> dovecot/imap(client_handle_input+0x125) [0x7effc73534c5] -> dovecot/imap(client_input+0x65) [0x7effc7353d75] -> /usr/lib/dovecot/libdovecot.so.0(io_loop_call_io+0x48) [0x7effc6c13c98] -> /usr/lib/dovecot/libdovecot.so.0(io_loop_handler_run+0xa7) [0x7effc6c14d27] -> /usr/lib/dovecot/libdovecot.so.0(io_loop_run+0x28) [0x7effc6c13c28] -> /usr/lib/dovecot/libdovecot.so.0(master_service_run+0x13) [0x7effc6c01e33] -> dovecot/imap(main+0x304) [0x7effc734b554] -> /lib/x86_64-linux-gnu/libc.so.6(__libc_start_main+0xed) [0x7effc683476d] -> dovecot/imap(+0x95e5) [0x7effc734b5e5]
Jun 27 16:25:19 wreckers dovecot: master: Error: service(imap): child 1993 killed with signal 6 (core dumped)

This mailing list message

http://www.dovecot.org/list/dovecot/2012-April/065035.html

indicates a fix

http://hg.dovecot.org/dovecot-2.1/rev/47526bf86c57

which I am now testing.

This only affects 12.04's version of dovecot 2.0.19. I believe this patch has already been applied to the dovecot 2.1.7 version which is in Quantal.

Related branches

Barry Warsaw (barry) wrote :

So far, that patch does seem to fix the crashes, and dovecot appears to be working again on my production 12.04 system. I'll now submit a merge proposal and SRU request.

Changed in dovecot (Ubuntu):
milestone: none → ubuntu-12.04.1
importance: Undecided → Critical
Barry Warsaw (barry) on 2012-06-27
description: updated
description: updated
Changed in dovecot (Ubuntu):
status: New → Fix Released
Changed in dovecot (Ubuntu Precise):
status: New → Confirmed
importance: Undecided → Critical
James Page (james-page) on 2012-06-29
Changed in dovecot (Ubuntu Precise):
milestone: none → ubuntu-12.04.1
Changed in dovecot (Ubuntu):
milestone: ubuntu-12.04.1 → none
Changed in dovecot (Ubuntu Precise):
assignee: nobody → Serge Hallyn (serge-hallyn)
Scott Kitterman (kitterman) wrote :

Although the test case is vague, I'm going to go ahead and accept this. Races are always tough.

Changed in dovecot (Ubuntu Precise):
status: Confirmed → Fix Committed

Hello Barry, or anyone else affected,

Accepted into precise-proposed. The package will build now and be available at http://launchpad.net/ubuntu/+source/None/1:2.0.19-0ubuntu2 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation how to enable and use -proposed. Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please change the bug tag from verification-needed to verification-done. If it does not, change the tag to verification-failed. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

James Page (james-page) on 2012-07-19
tags: added: verification-needed
Stéphane Graber (stgraber) wrote :

As stated on IRC, I did a minimal regression check, getting a precise container working with postfix and dovecot, sending a couple of test e-mails, retrieving them from dovecot, then upgrading to the new packages and testing again.

The race is apparently difficult to hit and doesn't have a clear test case. The patch was taken from upstream so it's hopefully sane.
Marking this bug verification-done on the basis that it's been waiting for almost 30 days and doesn't show any sign of regression.

tags: added: verification-done
removed: verification-needed

The verification of this Stable Release Update has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regresssions.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package dovecot - 1:2.0.19-0ubuntu2

---------------
dovecot (1:2.0.19-0ubuntu2) precise-proposed; urgency=low

  * Fix panic and core dump, cherry picked from upstream Mercurial.
    LP: #1018579
 -- Barry Warsaw <email address hidden> Wed, 27 Jun 2012 16:35:37 -0400

Changed in dovecot (Ubuntu Precise):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers